/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../../../index";
/**
 * Admins are teammate accounts that have access to a workspace.
 */
export interface Admin {
    /** String representing the object's type. Always has the value `admin`. */
    type?: "admin";
    /** The id representing the admin. */
    id: string;
    /** The name of the admin. */
    name: string;
    /** The email of the admin. */
    email: string;
    /** The job title of the admin. */
    job_title: string;
    /** Identifies if this admin is currently set in away mode. */
    away_mode_enabled: boolean;
    /** Identifies if this admin is set to automatically reassign new conversations to the apps default inbox. */
    away_mode_reassign: boolean;
    /** Identifies if this admin has a paid inbox seat to restrict/allow features that require them. */
    has_inbox_seat: boolean;
    /** This object represents the avatar associated with the admin. */
    team_ids: number[];
    /** The avatar object associated with the admin */
    avatar?: Admin.Avatar;
    team_priority_level?: Intercom.TeamPriorityLevel;
}
export declare namespace Admin {
    /**
     * The avatar object associated with the admin
     */
    interface Avatar {
        /** URL of the admin's avatar image */
        image_url: string;
    }
}
