/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../../../index";
/**
 * Data related to AI Agent involvement in the conversation.
 */
export interface AiAgent {
    /** The type of the source that triggered AI Agent involvement in the conversation. */
    source_type: AiAgent.SourceType;
    /** The title of the source that triggered AI Agent involvement in the conversation. If this is `essentials_plan_setup` then it will return `null`. */
    source_title?: string;
    /** The type of the last answer delivered by AI Agent. If no answer was delivered then this will return `null` */
    last_answer_type?: string;
    /** The resolution state of AI Agent. If no AI or custom answer has been delivered then this will return `null`. */
    resolution_state?: string;
    /** The customer satisfaction rating given to AI Agent, from 1-5. */
    rating?: number;
    /** The customer satisfaction rating remark given to AI Agent. */
    rating_remark?: string;
    content_sources?: Intercom.ContentSourcesList;
}
export declare namespace AiAgent {
    /**
     * The type of the source that triggered AI Agent involvement in the conversation.
     */
    type SourceType = "essentials_plan_setup" | "profile" | "workflow" | "workflow_preview" | "fin_preview";
    const SourceType: {
        readonly EssentialsPlanSetup: "essentials_plan_setup";
        readonly Profile: "profile";
        readonly Workflow: "workflow";
        readonly WorkflowPreview: "workflow_preview";
        readonly FinPreview: "fin_preview";
    };
}
