/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * The highlighted results of an Article search. In the examples provided my search query is always "my query".
 */
export interface ArticleSearchHighlights {
    /** The ID of the corresponding article. */
    article_id: string;
    /** An Article title highlighted. */
    highlighted_title: ArticleSearchHighlights.HighlightedTitle.Item[];
    /** An Article description and body text highlighted. */
    highlighted_summary: ArticleSearchHighlights.HighlightedSummary.Item[][];
}
export declare namespace ArticleSearchHighlights {
    type HighlightedTitle = HighlightedTitle.Item[];
    namespace HighlightedTitle {
        /**
         * A highlighted article title.
         */
        interface Item {
            /** The type of text - `highlight` or `plain`. */
            type?: Item.Type;
            /** The text of the title. */
            text?: string;
        }
        namespace Item {
            /**
             * The type of text - `highlight` or `plain`.
             */
            type Type = "highlight" | "plain";
            const Type: {
                readonly Highlight: "highlight";
                readonly Plain: "plain";
            };
        }
    }
    type HighlightedSummary = HighlightedSummary.Item[];
    namespace HighlightedSummary {
        /**
         * An instance of highlighted summary text.
         */
        interface Item {
            /** The type of text - `highlight` or `plain`. */
            type?: Item.Type;
            /** The text of the title. */
            text?: string;
        }
        namespace Item {
            /**
             * The type of text - `highlight` or `plain`.
             */
            type Type = "highlight" | "plain";
            const Type: {
                readonly Highlight: "highlight";
                readonly Plain: "plain";
            };
        }
    }
}
