/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
export declare namespace CustomChannelEvents {
    interface Options {
        environment?: core.Supplier<environments.IntercomEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the Intercom-Version header */
        version?: "1.0" | "1.1" | "1.2" | "1.3" | "1.4" | "2.0" | "2.1" | "2.2" | "2.3" | "2.4" | "2.5" | "2.6" | "2.7" | "2.8" | "2.9" | "2.10" | "2.11" | "Unstable";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
        /** Override the Intercom-Version header */
        version?: "1.0" | "1.1" | "1.2" | "1.3" | "1.4" | "2.0" | "2.1" | "2.2" | "2.3" | "2.4" | "2.5" | "2.6" | "2.7" | "2.8" | "2.9" | "2.10" | "2.11" | "Unstable";
    }
}
export declare class CustomChannelEvents {
    protected readonly _options: CustomChannelEvents.Options;
    constructor(_options?: CustomChannelEvents.Options);
    /**
     * @param {CustomChannelEvents.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.customChannelEvents.notifyAttributeCollected()
     */
    notifyAttributeCollected(requestOptions?: CustomChannelEvents.RequestOptions): Promise<void>;
    /**
     * @param {CustomChannelEvents.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.customChannelEvents.notifyNewMessage()
     */
    notifyNewMessage(requestOptions?: CustomChannelEvents.RequestOptions): Promise<void>;
    /**
     * @param {CustomChannelEvents.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.customChannelEvents.notifyNewConversation()
     */
    notifyNewConversation(requestOptions?: CustomChannelEvents.RequestOptions): Promise<void>;
    /**
     * @param {CustomChannelEvents.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.customChannelEvents.notifyQuickReplySelected()
     */
    notifyQuickReplySelected(requestOptions?: CustomChannelEvents.RequestOptions): Promise<void>;
    protected _getAuthorizationHeader(): Promise<string>;
}
