/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../../../index";
/**
 * Tickets are how you track requests from your users.
 */
export interface Ticket {
    /** Always ticket */
    type: "ticket";
    /** The unique identifier for the ticket which is given by Intercom. */
    id: string;
    /** The ID of the Ticket used in the Intercom Inbox and Messenger. Do not use ticket_id for API queries. */
    ticket_id: string;
    /** Category of the Ticket. */
    category: Ticket.Category;
    ticket_attributes: Intercom.TicketCustomAttributes;
    /** The state the ticket is currently in */
    ticket_state: Ticket.TicketState;
    ticket_type: Intercom.TicketType;
    contacts: Intercom.TicketContacts;
    /** The id representing the admin assigned to the ticket. */
    admin_assignee_id?: string;
    /** The id representing the team assigned to the ticket. */
    team_assignee_id?: string;
    /** The time the ticket was created as a UTC Unix timestamp. */
    created_at?: number;
    /** The last time the ticket was updated as a UTC Unix timestamp. */
    updated_at?: number;
    /** Whether or not the ticket is open. If false, the ticket is closed. */
    open?: boolean;
    /** The time the ticket will be snoozed until as a UTC Unix timestamp. If null, the ticket is not currently snoozed. */
    snoozed_until?: number;
    linked_objects?: Intercom.LinkedObjectList;
    ticket_parts?: Intercom.TicketParts;
    /** Whether or not the ticket is shared with the customer. */
    is_shared?: boolean;
    /** The state the ticket is currently in, in a human readable form - visible in Intercom */
    ticket_state_internal_label?: string;
    /** The state the ticket is currently in, in a human readable form - visible to customers, in the messenger, email and tickets portal. */
    ticket_state_external_label?: string;
}
export declare namespace Ticket {
    /**
     * Category of the Ticket.
     */
    type Category = "Customer" | "Back-office" | "Tracker";
    const Category: {
        readonly Customer: "Customer";
        readonly BackOffice: "Back-office";
        readonly Tracker: "Tracker";
    };
    /**
     * The state the ticket is currently in
     */
    type TicketState = "submitted" | "in_progress" | "waiting_on_customer" | "resolved";
    const TicketState: {
        readonly Submitted: "submitted";
        readonly InProgress: "in_progress";
        readonly WaitingOnCustomer: "waiting_on_customer";
        readonly Resolved: "resolved";
    };
}
