/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../index";
/**
 * Activities performed by Admins.
 */
export interface ActivityLog {
    /** The id representing the activity. */
    id: string;
    /** Details about the Admin involved in the activity. */
    performed_by: ActivityLog.PerformedBy;
    metadata?: Intercom.ActivityLogMetadata;
    /** The time the activity was created. */
    created_at?: number;
    activity_type: ActivityLog.ActivityType;
    /** A sentence or two describing the activity. */
    activity_description?: string;
}
export declare namespace ActivityLog {
    /**
     * Details about the Admin involved in the activity.
     */
    interface PerformedBy {
        /** String representing the object's type. Always has the value `admin`. */
        type?: "admin";
        /** The id representing the admin. */
        id?: string;
        /** The email of the admin. */
        email?: string;
        /** The IP address of the admin. */
        ip?: string;
    }
    type ActivityType = "admin_assignment_limit_change" | "admin_away_mode_change" | "admin_deletion" | "admin_deprovisioned" | "admin_impersonation_end" | "admin_impersonation_start" | "admin_invite_change" | "admin_invite_creation" | "admin_invite_deletion" | "admin_login_failure" | "admin_login_success" | "admin_logout" | "admin_password_reset_request" | "admin_password_reset_success" | "admin_permission_change" | "admin_provisioned" | "admin_two_factor_auth_change" | "admin_unauthorized_sign_in_method" | "app_admin_join" | "app_authentication_method_change" | "app_data_deletion" | "app_data_export" | "app_google_sso_domain_change" | "app_identity_verification_change" | "app_name_change" | "app_outbound_address_change" | "app_package_installation" | "app_package_token_regeneration" | "app_package_uninstallation" | "app_team_creation" | "app_team_deletion" | "app_team_membership_modification" | "app_timezone_change" | "app_webhook_creation" | "app_webhook_deletion" | "articles_in_messenger_enabled_change" | "bulk_delete" | "bulk_export" | "campaign_deletion" | "campaign_state_change" | "conversation_part_deletion" | "conversation_topic_change" | "conversation_topic_creation" | "conversation_topic_deletion" | "help_center_settings_change" | "inbound_conversations_change" | "inbox_access_change" | "message_deletion" | "message_state_change" | "messenger_look_and_feel_change" | "messenger_search_required_change" | "messenger_spaces_change" | "office_hours_change" | "role_change" | "role_creation" | "role_deletion" | "ruleset_activation_title_preview" | "ruleset_creation" | "ruleset_deletion" | "search_browse_enabled_change" | "search_browse_required_change" | "seat_change" | "seat_revoke" | "security_settings_change" | "temporary_expectation_change" | "upfront_email_collection_change" | "welcome_message_change";
    const ActivityType: {
        readonly AdminAssignmentLimitChange: "admin_assignment_limit_change";
        readonly AdminAwayModeChange: "admin_away_mode_change";
        readonly AdminDeletion: "admin_deletion";
        readonly AdminDeprovisioned: "admin_deprovisioned";
        readonly AdminImpersonationEnd: "admin_impersonation_end";
        readonly AdminImpersonationStart: "admin_impersonation_start";
        readonly AdminInviteChange: "admin_invite_change";
        readonly AdminInviteCreation: "admin_invite_creation";
        readonly AdminInviteDeletion: "admin_invite_deletion";
        readonly AdminLoginFailure: "admin_login_failure";
        readonly AdminLoginSuccess: "admin_login_success";
        readonly AdminLogout: "admin_logout";
        readonly AdminPasswordResetRequest: "admin_password_reset_request";
        readonly AdminPasswordResetSuccess: "admin_password_reset_success";
        readonly AdminPermissionChange: "admin_permission_change";
        readonly AdminProvisioned: "admin_provisioned";
        readonly AdminTwoFactorAuthChange: "admin_two_factor_auth_change";
        readonly AdminUnauthorizedSignInMethod: "admin_unauthorized_sign_in_method";
        readonly AppAdminJoin: "app_admin_join";
        readonly AppAuthenticationMethodChange: "app_authentication_method_change";
        readonly AppDataDeletion: "app_data_deletion";
        readonly AppDataExport: "app_data_export";
        readonly AppGoogleSsoDomainChange: "app_google_sso_domain_change";
        readonly AppIdentityVerificationChange: "app_identity_verification_change";
        readonly AppNameChange: "app_name_change";
        readonly AppOutboundAddressChange: "app_outbound_address_change";
        readonly AppPackageInstallation: "app_package_installation";
        readonly AppPackageTokenRegeneration: "app_package_token_regeneration";
        readonly AppPackageUninstallation: "app_package_uninstallation";
        readonly AppTeamCreation: "app_team_creation";
        readonly AppTeamDeletion: "app_team_deletion";
        readonly AppTeamMembershipModification: "app_team_membership_modification";
        readonly AppTimezoneChange: "app_timezone_change";
        readonly AppWebhookCreation: "app_webhook_creation";
        readonly AppWebhookDeletion: "app_webhook_deletion";
        readonly ArticlesInMessengerEnabledChange: "articles_in_messenger_enabled_change";
        readonly BulkDelete: "bulk_delete";
        readonly BulkExport: "bulk_export";
        readonly CampaignDeletion: "campaign_deletion";
        readonly CampaignStateChange: "campaign_state_change";
        readonly ConversationPartDeletion: "conversation_part_deletion";
        readonly ConversationTopicChange: "conversation_topic_change";
        readonly ConversationTopicCreation: "conversation_topic_creation";
        readonly ConversationTopicDeletion: "conversation_topic_deletion";
        readonly HelpCenterSettingsChange: "help_center_settings_change";
        readonly InboundConversationsChange: "inbound_conversations_change";
        readonly InboxAccessChange: "inbox_access_change";
        readonly MessageDeletion: "message_deletion";
        readonly MessageStateChange: "message_state_change";
        readonly MessengerLookAndFeelChange: "messenger_look_and_feel_change";
        readonly MessengerSearchRequiredChange: "messenger_search_required_change";
        readonly MessengerSpacesChange: "messenger_spaces_change";
        readonly OfficeHoursChange: "office_hours_change";
        readonly RoleChange: "role_change";
        readonly RoleCreation: "role_creation";
        readonly RoleDeletion: "role_deletion";
        readonly RulesetActivationTitlePreview: "ruleset_activation_title_preview";
        readonly RulesetCreation: "ruleset_creation";
        readonly RulesetDeletion: "ruleset_deletion";
        readonly SearchBrowseEnabledChange: "search_browse_enabled_change";
        readonly SearchBrowseRequiredChange: "search_browse_required_change";
        readonly SeatChange: "seat_change";
        readonly SeatRevoke: "seat_revoke";
        readonly SecuritySettingsChange: "security_settings_change";
        readonly TemporaryExpectationChange: "temporary_expectation_change";
        readonly UpfrontEmailCollectionChange: "upfront_email_collection_change";
        readonly WelcomeMessageChange: "welcome_message_change";
    };
}
