/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../index";
/**
 * You have to respond to the majority of requests with a canvas object. This will tell us what UI to show for your app.
 *
 * A canvas can either be static (meaning we send you the next request only when an action takes place) or live (meaning we send you the next request when someone views the app).
 *
 * - A static canvas needs a ContentObject which will contain the components to show.
 * - A live canvas needs a `content_url` which we we will make the Live Canvas requests to when the app is viewed. This is only possible for apps viewed or used in the Messenger.
 */
export interface CanvasObject {
    /** The content object that will be shown as the UI of the app. Max Size is 64KB. */
    content: Intercom.ContentObject;
    /** The URL which we make Live Canvas requests to. You must respond to these with a content object. Max size is 64KB. */
    content_url?: string;
    /** Optional Stored Data that you want to be returned in the next sent request. Max Size is 64KB. */
    stored_data?: Record<string, unknown>;
}
