/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../index";
/**
 * A Conversation Part represents a message in the conversation.
 */
export interface ConversationPart {
    /** Always conversation_part */
    type: "conversation_part";
    /** The id representing the conversation part. */
    id: string;
    /** The type of conversation part. */
    part_type: string;
    /** The message body, which may contain HTML. For Twitter, this will show a generic message regarding why the body is obscured. */
    body?: string;
    /** The time the conversation part was created. */
    created_at: number;
    /** The last time the conversation part was updated. */
    updated_at?: number;
    /** The time the user was notified with the conversation part. */
    notified_at: number;
    /** The id of the admin that was assigned the conversation by this conversation_part (null if there has been no change in assignment.) */
    assigned_to?: Intercom.Reference;
    author: Intercom.ConversationPartAuthor;
    /** A list of attachments for the part. */
    attachments?: Intercom.PartAttachment[];
    /** The external id of the conversation part */
    external_id?: string;
    /** Whether or not the conversation part has been redacted. */
    redacted: boolean;
}
