/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../index";
/**
 * The Submit request is triggered when a component with a submit action is interacted with in Messenger Inbox.
 */
export interface SubmitRequest {
    /** The workspace ID of the teammate. Attribute is `app_id` for V1.2 and below. */
    workspace_id: string;
    /** The Intercom hosted region that this app is located in. */
    workspace_region: string;
    /** The Intercom teammate viewing the conversation. */
    admin: Intercom.Admin;
    /** The id of the component clicked by the teammate to trigger the request. */
    component_id: string;
    /** The context of where the app is added, where the user last visited, and information on the Messenger settings. */
    context: Intercom.Context;
    /** The conversation where your app is being shown. */
    conversation: Intercom.Conversation;
    /** The current canvas the teammate can see. */
    current_canvas: Intercom.CurrentCanvas;
    /** The contact which is currently being viewed by the teammate in the conversation details panel. */
    contact: Intercom.Contact;
    /** A list of key/value pairs of data, inputted by the teammate on the current canvas. */
    input_values: Record<string, unknown>;
    /** The user who took the action. */
    user: Intercom.Contact;
}
