/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * A text component is used for rendering blocks of text. Links and bold font can be rendered through Markdown. There are different styles provided which edit the color, weight, and font size. These cannot be edited through Markdown.
 */
export interface TextComponent {
    /** A unique identifier for the component. */
    id?: string;
    /** The text that will be rendered. */
    text: string;
    /** Aligns the text. Default is `left`. */
    align?: TextComponent.Align;
    /** Styles the text. Default is `paragraph`. */
    style?: TextComponent.Style;
    /** Disables a component's margin-bottom of 10px. */
    bottom_margin?: "none";
}
export declare namespace TextComponent {
    /**
     * Aligns the text. Default is `left`.
     */
    type Align = "left" | "center" | "right";
    const Align: {
        readonly Left: "left";
        readonly Center: "center";
        readonly Right: "right";
    };
    /**
     * Styles the text. Default is `paragraph`.
     */
    type Style = "header" | "paragraph" | "muted" | "error";
    const Style: {
        readonly Header: "header";
        readonly Paragraph: "paragraph";
        readonly Muted: "muted";
        readonly Error: "error";
    };
}
