/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../../../index";
/**
 * The data returned about your articles when you list them.
 */
export interface ArticleListItem {
    /** The type of object - `article`. */
    type?: "article";
    /** The unique identifier for the article which is given by Intercom. */
    id: string;
    /** The id of the workspace which the article belongs to. */
    workspace_id: string;
    /** The title of the article. For multilingual articles, this will be the title of the default language's content. */
    title: string;
    /** The description of the article. For multilingual articles, this will be the description of the default language's content. */
    description?: string;
    /** The body of the article in HTML. For multilingual articles, this will be the body of the default language's content. */
    body?: string;
    /** The id of the author of the article. For multilingual articles, this will be the id of the author of the default language's content. Must be a teammate on the help center's workspace. */
    author_id: number;
    /** Whether the article is `published` or is a `draft`. For multilingual articles, this will be the state of the default language's content. */
    state: ArticleListItem.State;
    /** The time when the article was created. For multilingual articles, this will be the timestamp of creation of the default language's content in seconds. */
    created_at: number;
    /** The time when the article was last updated. For multilingual articles, this will be the timestamp of last update of the default language's content in seconds. */
    updated_at: number;
    /** The URL of the article. For multilingual articles, this will be the URL of the default language's content. */
    url?: string;
    /** The id of the article's parent collection or section. An article without this field stands alone. */
    parent_id?: number;
    /** The ids of the article's parent collections or sections. An article without this field stands alone. */
    parent_ids?: number[];
    /** The type of parent, which can either be a `collection` or `section`. */
    parent_type?: string;
    /** The default locale of the help center. This field is only returned for multilingual help centers. */
    default_locale: string;
    translated_content: Intercom.ArticleTranslatedContent;
}
export declare namespace ArticleListItem {
    /**
     * Whether the article is `published` or is a `draft`. For multilingual articles, this will be the state of the default language's content.
     */
    type State = "published" | "draft";
    const State: {
        readonly Published: "published";
        readonly Draft: "draft";
    };
}
