/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Intercom from "../../../index";
export declare namespace Notes {
    interface Options {
        environment?: core.Supplier<environments.IntercomEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the Intercom-Version header */
        version?: "1.0" | "1.1" | "1.2" | "1.3" | "1.4" | "2.0" | "2.1" | "2.2" | "2.3" | "2.4" | "2.5" | "2.6" | "2.7" | "2.8" | "2.9" | "2.10" | "2.11" | "Unstable";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
        /** Override the Intercom-Version header */
        version?: "1.0" | "1.1" | "1.2" | "1.3" | "1.4" | "2.0" | "2.1" | "2.2" | "2.3" | "2.4" | "2.5" | "2.6" | "2.7" | "2.8" | "2.9" | "2.10" | "2.11" | "Unstable";
    }
}
/**
 * Everything about your Notes
 */
export declare class Notes {
    protected readonly _options: Notes.Options;
    constructor(_options?: Notes.Options);
    /**
     * You can fetch a list of notes that are associated to a contact.
     *
     * @param {Intercom.ListContactNotesRequest} request
     * @param {Notes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Intercom.NotFoundError}
     *
     * @example
     *     await client.notes.list({
     *         contact_id: "contact_id"
     *     })
     */
    list(request: Intercom.ListContactNotesRequest, requestOptions?: Notes.RequestOptions): Promise<core.Page<Intercom.Note>>;
    /**
     * You can add a note to a single contact.
     *
     * @param {Intercom.CreateContactNoteRequest} request
     * @param {Notes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Intercom.NotFoundError}
     *
     * @example
     *     await client.notes.create({
     *         contact_id: "123",
     *         body: "Hello",
     *         admin_id: "123"
     *     })
     */
    create(request: Intercom.CreateContactNoteRequest, requestOptions?: Notes.RequestOptions): Promise<Intercom.Note>;
    /**
     * You can fetch the details of a single note.
     *
     * @param {Intercom.FindNoteRequest} request
     * @param {Notes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Intercom.UnauthorizedError}
     * @throws {@link Intercom.NotFoundError}
     *
     * @example
     *     await client.notes.find({
     *         note_id: "1"
     *     })
     */
    find(request: Intercom.FindNoteRequest, requestOptions?: Notes.RequestOptions): Promise<Intercom.Note>;
    protected _getAuthorizationHeader(): Promise<string>;
}
