/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * @example
 *     {
 *         ticket_type_id: "ticket_type_id",
 *         attribute_id: "attribute_id",
 *         description: "New Attribute Description"
 *     }
 */
export interface UpdateTicketTypeAttributeRequest {
    /**
     * The unique identifier for the ticket type which is given by Intercom.
     */
    ticket_type_id: string;
    /**
     * The unique identifier for the ticket type attribute which is given by Intercom.
     */
    attribute_id: string;
    /** The name of the ticket type attribute */
    name?: string;
    /** The description of the attribute presented to the teammate or contact */
    description?: string;
    /** Whether the attribute is required to be filled in when teammates are creating the ticket in Inbox. */
    required_to_create?: boolean;
    /** Whether the attribute is required to be filled in when contacts are creating the ticket in Messenger. */
    required_to_create_for_contacts?: boolean;
    /** Whether the attribute is visible to teammates when creating a ticket in Inbox. */
    visible_on_create?: boolean;
    /** Whether the attribute is visible to contacts when creating a ticket in Messenger. */
    visible_to_contacts?: boolean;
    /** Whether the attribute allows multiple lines of text (only applicable to string attributes) */
    multiline?: boolean;
    /** A comma delimited list of items for the attribute value (only applicable to list attributes) */
    list_items?: string;
    /** Whether the attribute allows multiple files to be attached to it (only applicable to file attributes) */
    allow_multiple_values?: boolean;
    /** Whether the attribute should be archived and not shown during creation of the ticket (it will still be present on previously created tickets) */
    archived?: boolean;
}
