/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../index";
/**
 * A dropdown component is used to capture a choice from the options that you provide.
 *
 * When submitted, the dropdown choices are returned in a hash with the id from the dropdown component used as the key and the id from the chosen option as the value.
 */
export interface DropdownComponent {
    /** A unique identifier for the component. */
    id: string;
    /** The list of options. Can provide 2 to 10. */
    options: Intercom.DropdownOption[];
    /** The text shown above the dropdown. */
    label?: string;
    /** The option that is selected by default. */
    value?: string;
    /** Styles all options and prevents the action. Default is `unsaved`. Will be overridden if `save_state` is `saved`. */
    save_state?: DropdownComponent.SaveState;
    /** Styles all options and prevents the action. Default is false. Will be overridden if save_state is saved. */
    disabled?: boolean;
}
export declare namespace DropdownComponent {
    /**
     * Styles all options and prevents the action. Default is `unsaved`. Will be overridden if `save_state` is `saved`.
     */
    type SaveState = "unsaved" | "saved" | "failed";
    const SaveState: {
        readonly Unsaved: "unsaved";
        readonly Saved: "saved";
        readonly Failed: "failed";
    };
}
