/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../index";
/**
 * An image component is used to display an image.
 *
 * HTTPS Images:
 * If your request URLs (or website URLs) are over HTTPS, you will need to ensure that images are loaded over HTTPS likewise. Otherwise, they will not work.
 */
export interface ImageComponent {
    /** A unique identifier for the component. */
    id?: string;
    /** The URL where the image is located. */
    url: string;
    /** Aligns the image inside the component. Default is `left`. */
    align?: ImageComponent.Align;
    /** The exact width of the image in pixels. */
    width: number;
    /** The exact height of the image in pixels. */
    height: number;
    /** Rounds the corners of the image. Default is `false`. */
    rounded?: boolean;
    /** Disables a component's margin-bottom of 10px. */
    bottom_margin?: "none";
    /** This can be a URL Action only. */
    action?: Intercom.UrlActionComponent;
}
export declare namespace ImageComponent {
    /**
     * Aligns the image inside the component. Default is `left`.
     */
    type Align = "left" | "center" | "right" | "full_width";
    const Align: {
        readonly Left: "left";
        readonly Center: "center";
        readonly Right: "right";
        readonly FullWidth: "full_width";
    };
}
