/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Intercom from "../index";
/**
 * Canvases are static by default and require a new request to come through in order to update them. Live canvases however will make requests every time the card is viewed without any interaction needed, meaning the canvas can be kept up-to-date with no action from the user.
 *
 * This works for every Messenger request that you can respond with a canvas object to. Instead of returning the content object within the canvas object, you should provide a `content_url` attribute instead with the value being the URL you want us to send a POST request to when someone views the app.
 */
export interface LiveCanvasRequest {
    /** The workspace ID of the teammate. Attribute is `app_id` for V1.2 and below. */
    workspace_id: string;
    /** The Intercom hosted region that this app is located in. */
    workspace_region: string;
    /** The current_canvas the teammate can see. */
    canvas: Intercom.CanvasObject;
    /** The context of where the app is added, where the user last visited, and information on the Messenger settings. */
    context: Intercom.Context;
    /** The contact who viewed the card. */
    contact: Intercom.Contact;
}
